Package: RNAmodR.RiboMethSeq
Type: Package
Title: Detection of 2'-O methylations by RiboMethSeq
Version: 1.27.0
Date: 2025-09-25
Authors@R: c(person("Felix G.M.", 
                    "Ernst", 
                    email = "felix.gm.ernst@outlook.com", 
                    role = c("aut", "cre"),
                    comment = c(ORCID = "0000-0001-5064-0928")),
             person("Denis L.J.", 
                    "Lafontaine", 
                    email = "denis.lafontaine@ulb.ac.be", 
                    role = c("ctb", "fnd")))
Description: RNAmodR.RiboMethSeq implements the detection of 2'-O methylations
    on RNA from experimental data generated with the RiboMethSeq protocol. 
    The package builds on the core functionality of the RNAmodR package to
    detect specific patterns of the modifications in high throughput sequencing
    data.
biocViews: Software, WorkflowStep, Visualization, Sequencing
License: Artistic-2.0
Encoding: UTF-8
LazyData: false
Depends: R (>= 4.0), RNAmodR (>= 1.5.3)
Imports: methods, S4Vectors, BiocGenerics, IRanges, GenomicRanges, Gviz
Suggests: BiocStyle, knitr, rmarkdown, testthat, rtracklayer, Seqinfo,
        RNAmodR.Data
Collate: 'RNAmodR.RiboMethSeq.R' 'Modifier-RiboMethSeq-class.R'
        'Modifier-RiboMethSeq-viz.R'
VignetteBuilder: knitr
RoxygenNote: 7.3.3
BugReports: https://github.com/FelixErnst/RNAmodR.RiboMethSeq/issues
URL: https://github.com/FelixErnst/RNAmodR.RiboMethSeq
git_url: https://git.bioconductor.org/packages/RNAmodR.RiboMethSeq
git_branch: devel
git_last_commit: 6f2e754
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:45:11 UTC; biocbuild
Author: Felix G.M. Ernst [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5064-0928>),
  Denis L.J. Lafontaine [ctb, fnd]
Maintainer: Felix G.M. Ernst <felix.gm.ernst@outlook.com>

# RNAmodR.RiboMethSeq [![Build Status](https://travis-ci.com/FelixErnst/RNAmodR.RiboMethSeq.svg?branch=master)](https://travis-ci.com/FelixErnst/RNAmodR.RiboMethSeq) [![codecov](https://codecov.io/gh/FelixErnst/RNAmodR.RiboMethSeq/branch/master/graph/badge.svg)](https://codecov.io/gh/FelixErnst/RNAmodR.RiboMethSeq)

`RNAmodR.RiboMethSeq` uses classes and workflows from `RNAmodR` to detect 2'-O
methylations from RiboMethSeq data.

The vignette from the `RNAmodR.RiboMethSeq` package provides details on the
specific analysis of RiboMethSeq data. Have a look at the vignette from the
`RNAmodR` package for a general description on the provided workflows.

# Installation

The current version of the RNAmodR.RiboMethSeq package is available from 
Bioconductor.

```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following initializes usage of Bioc devel
BiocManager::install("RNAmodR.RiboMethSeq")
library(RNAmodR.RiboMethSeq)
```

# Literature

- Birkedal U, Christensen-Dalsgaard M, Krogh N, Sabarinathan R, Gorodkin J,
Nielsen H (2015): "Profiling of ribose methylations in RNA by high-throughput
sequencing." Angewandte Chemie (International ed. in English) 54 (2),
P. 451–455. DOI: 
[10.1002/anie.201408362](https://doi.org/10.1002/anie.201408362).

- Marchand V, Ayadi L, El Hajj A, Blanloeil-Oillo F, Helm M, Motorin Y
(2017): "High-Throughput Mapping of 2'-O-Me Residues in RNA Using
Next-Generation Sequencing (Illumina RiboMethSeq Protocol)." Methods in
molecular biology (Clifton, N.J.) 1562, P. 171–187. DOI:
[10.1007/978-1-4939-6807-7_12](https://doi.org/10.1007/978-1-4939-6807-7_12).

- Galvanin A, Ayadi L, Helm M, Motorin Y, Marchand V (2017): "Mapping and
Quantification of tRNA 2'-O-Methylation by RiboMethSeq". Wajapeyee N., Gupta
R. (eds) Epitranscriptomics. Methods in Molecular Biology (Humana Press,
New York, NY) 1870, P. 273-295. DOI:
[10.1007/978-1-4939-8808-2_21](https://doi.org/10.1007/978-1-4939-8808-2_21).

#' @include RNAmodR.RiboMethSeq.R
#' @include Modifier-RiboMethSeq-class.R
NULL

RNAMODR_RMS_PLOT_DATA <- c("ends",
                           "scoreA",
                           "scoreB",
                           "scoreRMS",
                           "scoreMean")
RNAMODR_RMS_PLOT_DATA_DEFAULT <- c("scoreRMS")
RNAMODR_RMS_PLOT_DATA_NAMES <- c(ends = "5'- & 3'-ends",
                                 scoreA = "Score A",
                                 scoreB = "Score B",
                                 scoreRMS = "Score RiboMethSeq",
                                 scoreMean = "ScoreMean")
RNAMODR_RMS_PLOT_DATA_COLOURS <- c(ends = "#FBB4AE",
                                   scoreA = "#B3CDE3",
                                   scoreB = "#CCEBC5",
                                   scoreRMS = "#DECBE4",
                                   scoreMean = "#DECBE4")

.norm_viz_mod_rms_args <- function(input, type){
  if(!all(type %in% RNAMODR_RMS_PLOT_DATA)){
    stop("Type '",type,"' is not valid. Valid types are: '",
         paste0(RNAMODR_RMS_PLOT_DATA, collapse = "','"),"'.",
         call. = FALSE)
  }
  colour <- input[["colour"]]
  if(!is.null(input[["colour"]])){
    colour <- RNAmodR:::.norm_viz_colour(input[["colour"]], type)
  } else {
    colour <- RNAMODR_RMS_PLOT_DATA_COLOURS[type]
  }
  input <- list(type = type,
                colour = colour)
  input
}

#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "getDataTrack",
  signature = signature(x = "ModRiboMethSeq"),
  definition = function(x, name, type, ...) {
    args <- .norm_viz_mod_rms_args(list(...), type)
    data <- RNAmodR:::.get_data_for_visualization(x, name)
    data <- unlist(data)
    dts <- lapply(
      args[["type"]],
      function(t){
        dt <- Gviz::DataTrack(range = data[,t],
                              groups = factor(t),
                              name = RNAMODR_RMS_PLOT_DATA_NAMES[t],
                              col = args[["colour"]][t],
                              type = "histogram")
        if(t %in% c("scoreA","scoreRMS","scoreMean")){
          Gviz::displayPars(dt)$ylim = c(0,1)
        }
        Gviz::displayPars(dt)$background.title <- "#FFFFFF"
        Gviz::displayPars(dt)$fontcolor.title <- "#000000"
        Gviz::displayPars(dt)$col.axis <- "#000000"
        Gviz::displayPars(dt) <- args[names(args) != "type"]
        dt
      })
    names(dts) <- args[["type"]]
    dts
  }
)

#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "plotDataByCoord",
  signature = signature(x = "ModRiboMethSeq",
                        coord = "GRanges"),
  definition = function(x, coord,
                        type = c("ends","scoreA","scoreB","scoreRMS","scoreMean"),
                        window.size = 15L,
                        ...) {
    if(missing(type)){
      type <- RNAMODR_RMS_PLOT_DATA_DEFAULT
    }
    type <- match.arg(type,c("scoreRMS","ends","scoreA","scoreB","scoreMean"),
                      several.ok = TRUE)
    callNextMethod(x = x, coord = coord, type = type, window.size = window.size,
                   ...)
  }
)
#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "plotData",
  signature = signature(x = "ModRiboMethSeq"),
  definition = function(x, name, from, to,
                        type = c("ends","scoreA","scoreB","scoreRMS","scoreMean"), ...) {
    if(missing(type)){
      type <- RNAMODR_RMS_PLOT_DATA_DEFAULT
    }
    type <- match.arg(type,c("scoreRMS","ends","scoreA","scoreB","scoreMean"),
                      several.ok = TRUE)
    callNextMethod(x = x, name = name, from = from, to = to, type = type, ...)
  }
)

#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "plotDataByCoord",
  signature = signature(x = "ModSetRiboMethSeq",
                        coord = "GRanges"),
  definition = function(x, coord,
                        type = c("scoreRMS","ends","scoreA","scoreB","scoreMean"),
                        window.size = 15L,
                        ...) {
    if(missing(type)){
      type <- RNAMODR_RMS_PLOT_DATA_DEFAULT
    }
    type <- match.arg(type,c("scoreRMS","ends","scoreA","scoreB","scoreMean"),
                      several.ok = TRUE)
    callNextMethod(x = x, coord = coord, type = type, window.size = window.size,
                   ...)
  }
)
#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "plotData",
  signature = signature(x = "ModSetRiboMethSeq"),
  definition = function(x, name, from, to,
                        type = c("scoreRMS","ends","scoreA","scoreB","scoreMean"), ...) {
    if(missing(type)){
      type <- RNAMODR_RMS_PLOT_DATA_DEFAULT
    }
    type <- match.arg(type,c("scoreRMS","ends","scoreA","scoreB","scoreMean"),
                      several.ok = TRUE)
    callNextMethod(x = x, name = name, from = from, to = to, type = type, ...)
  }
)

#' @include RNAmodR.RiboMethSeq.R
NULL

#' @name ModRiboMethSeq
#' @aliases RiboMethSeq ModRiboMethSeq ModSetRiboMethSeq
#' 
#' @author Felix G.M. Ernst [aut]
#' 
#' @title ModRiboMethSeq class to analyze RiboMethSeq data
#' 
#' @description
#' Among the various post-transcriptional RNA modifications, 2'-O methylations
#' are quite common in rRNA and tRNA. They confere resistance to alkaline 
#' degradation by preventing a nucleophilic attack on the 3'-phosphate 
#' especially in flexible RNA, which is fascilitated by high pH conditions.
#' This property can be queried using a method called RiboMethSeq (Birkedahl et 
#' al. 2015, Marchand et al. 2017) for which RNA is treated in alkaline 
#' conditions and RNA fragments are used to prepare a sequencing library.
#' 
#' At position containing a 2'-O methylations, read ends are less frequent, 
#' which is used to detect and score the2'-O methylations.
#' 
#' \code{dataType} is \code{"ProtectedEndSequenceData"}:
#' 
#' The \code{ModRiboMethSeq} class uses the the 
#' \code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}
#' class to store and aggregate data along the transcripts. The calculated 
#' scores follow the nomenclature of Birkedahl et al. (2015) with the names
#' \code{scoreRMS} (default), \code{scoreA}, \code{scoreB} and \code{scoreMean}.
#' 
#' The ScoreMax as described by Marchand et al. (2017) are not implemented, 
#' yet, since an unambigeous description is not available from the literature.
#' 
#' The ScoreMean as described by Galvanin et al. (2018) is implemented. However,
#' use with caution, since the description is not unambigeous. Currently it is
#' calculated as as: 1 - (n / mean(areaL + areaR)). (n: counts at position, 
#' areaL: counts from x position upstream, areaR: counts from x position 
#' downstream)
#' 
#' Only samples named \code{treated} are used for this analysis. Normalization 
#' to untreated samples is currently not used.
#' 
#' The \code{ModRiboMethSeq5} class can be used as well. However, as 
#' \code{SequenceData} the 
#' \code{\link[RNAmodR:EndSequenceData-class]{End5SequenceData}} is employed using
#' only the 5'-end positions of reads.
#' 
#' @param x the input which can be of the different types depending on whether
#' a \code{ModRiboMethSeq} or a \code{ModSetRiboMethSeq} object is to be 
#' constructed. For more information have a look at the documentation of
#' the \code{\link[RNAmodR:Modifier-class]{Modifier}} and 
#' \code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} classes.
#' @param annotation annotation data, which must match the information contained
#' in the BAM files. This is parameter is only required if \code{x} if not a 
#' \code{Modifier} object.
#' @param sequences sequences matching the target sequences the reads were 
#' mapped onto. This must match the information contained in the BAM files. This
#' is parameter is only required if \code{x} if not a \code{Modifier} object.
#' @param seqinfo An optional \code{\link[Seqinfo:Seqinfo-class]{Seqinfo}} 
#' argument or character vector, which can be coerced to one, to subset the 
#' sequences to be analyzed on a per chromosome basis.
#' @param ... Optional arguments overwriting default values, which are
#' \itemize{
#' \item weights: The weights used for calculating the scores B and RMS 
#' (default: \code{weights = c(0.9,1,0,1,0.9)}).
#' \item flankingRegion: The size of the flanking region used for calculation 
#' of score A as an integer value (default: \code{flankingRegion = 6L}).
#' \item minSignal: The minimal signal at the position as integer value 
#' (default: \code{minSignal = 10L}). If the reaction is very specific a lower
#' value and even 0L may need to be used.
#' \item minScoreA: minimum for score A to identify 2'-O methylated positions 
#' de novo (default: \code{minScoreA = 0.6}).
#' \item minScoreB: minimum for score B to identify 2'-O methylated positions 
#' de novo (default: \code{minScoreB = 3.0}).
#' \item minScoreRMS: minimum for score RMS to identify 2'-O methylated 
#' positions de novo (default: \code{minScoreRMS = 0.75}).
#' \item minScoreMean: minimum for ScoreMean to identify 2'-O methylated 
#' positions de novo (default: \code{minScoreMean = 0.75}).
#' \item flankingRegionMean: The size of the flanking region used for 
#' calculation of ScoreMean as an integer value (default: 
#' \code{flankingRegionMean = 2L}).
#' \item scoreOperator: how the minimal score should be used as logical 
#' operator. "&" requires all minimal values to be exceeded, whereas "|" detects
#' positions, if at least one minimal values is exceeded (default: 
#' \code{scoreOperator = "&"}).
#' \item maxLength: The default read length. Reads with this length or longer
#' are discarded, since they represent non-fragmented reads. This might need to
#' be adjusted for individual samples depending on the experimental conditions.
#' This is argument is passed on to 
#' \code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}
#' (default: \code{maxLength = 50L}).
#' \item other arguments which are passed on to 
#' \code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}.
#' }
#' To disable minimal values for modification calling, set them to \code{0}.
#' It is not advised to set them all to \code{0}.
#' 
#' @return a \code{ModRiboMethSeq} or \code{ModSetRiboMethSeq} object
#' 
#' @references 
#' - Birkedal U, Christensen-Dalsgaard M, Krogh N, Sabarinathan R, Gorodkin J, 
#' Nielsen H (2015): "Profiling of ribose methylations in RNA by high-throughput
#' sequencing." Angewandte Chemie (International ed. in English) 54 (2), 
#' P. 451–455. DOI: 
#' \href{https://doi.org/10.1002/anie.201408362}{10.1002/anie.201408362}.
#' 
#' - Marchand V, Ayadi L, El Hajj A, Blanloeil-Oillo F, Helm M, Motorin Y 
#' (2017): "High-Throughput Mapping of 2'-O-Me Residues in RNA Using 
#' Next-Generation Sequencing (Illumina RiboMethSeq Protocol)." Methods in 
#' molecular biology (Clifton, N.J.) 1562, P. 171–187. DOI: 
#' \href{https://doi.org/10.1007/978-1-4939-6807-7_12}{10.1007/978-1-4939-6807-7_12}.
#' 
#' - Galvanin A, Ayadi L, Helm M, Motorin Y, Marchand V (2017): "Mapping and 
#' Quantification of tRNA 2'-O-Methylation by RiboMethSeq". Wajapeyee N., Gupta
#' R. (eds) Epitranscriptomics. Methods in Molecular Biology (Humana Press, 
#' New York, NY) 1870, P. 273-295. DOI: 
#' \href{https://doi.org/10.1007/978-1-4939-8808-2_21}{10.1007/978-1-4939-8808-2_21}
#' 
#' @examples
#' library(RNAmodR.Data)
#' library(rtracklayer)
#' annotation <- GFF3File(RNAmodR.Data.example.RMS.gff3())
#' sequences <- RNAmodR.Data.example.RMS.fasta()
#' files <- list("Sample1" = c(treated = RNAmodR.Data.example.RMS.1()),
#'               "Sample2" = c(treated = RNAmodR.Data.example.RMS.1()))
#' # Creating a Modifier object of type ModRiboMethSeq
#' mrms <- ModRiboMethSeq(files[[1]], annotation = annotation, sequences = sequences)
#' # Creating a ModifierSet object of type ModSetRiboMethSeq
#' msrms <- ModSetRiboMethSeq(files, annotation = annotation, sequences = sequences)
NULL

#' @rdname ModRiboMethSeq
#' @export
setClass("ModRiboMethSeq",
         contains = c("RNAModifier"),
         prototype = list(mod = c("Am","Cm","Gm","Um"),
                          score = "scoreRMS",
                          dataType = "ProtectedEndSequenceData"))

# constructor ------------------------------------------------------------------

#' @rdname ModRiboMethSeq
#' @export
ModRiboMethSeq <- function(x, annotation = NA, sequences = NA, seqinfo = NA,
                           ...){
  RNAmodR::Modifier("ModRiboMethSeq", x = x, annotation = annotation,
                     sequences = sequences, seqinfo = seqinfo, ...)
}

# settings ---------------------------------------------------------------------

#' @name ModRiboMethSeq-functions
#' @aliases aggregate modify settings plotData plotDataByCoord
#' 
#' @title Functions for ModRiboMethSeq
#' 
#' @description
#' All of the functions of \code{\link[RNAmodR:Modifier-class]{Modifier}} and
#' the \code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} classes are
#' inherited by the \code{ModRiboMethSeq} and \code{ModSetRiboMethSeq} classes.
#' 
#' @param x a \code{\link[RNAmodR:Modifier-class]{Modifier}} or a
#' \code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} object. For more
#' details see also the man pages for the functions mentioned below.
#' @param value See \code{\link[RNAmodR:Modifier-class]{settings}}
#' @param coord,name,from,to,type,window.size,... See 
#' \code{\link[RNAmodR:plotData]{plotData}}
#' 
#' @details 
#' \code{ModRiboMethSeq} specific arguments for 
#' \code{\link[RNAmodR:plotData]{plotData}}:
#' \itemize{
#' \item \code{colour} - a named character vector of \code{length = 4} 
#' for the colours of the individual histograms. The names are expected to be 
#' \code{c("ends","scoreA","scoreB","scoreRMS","scoreMean")}.
#' }
#' 
#' @return 
#' \itemize{
#' \item \code{settings}: See \code{\link[RNAmodR:Modifier-functions]{settings}}.
#' \item \code{aggregate}: See \code{\link[RNAmodR:aggregate]{aggregate}}.
#' \item \code{modify}: See \code{\link[RNAmodR:modify]{modify}}.
#' \item \code{getDataTrack}: a list of 
#' \code{\link[Gviz:DataTrack-class]{DataTrack}} object.
#' \item \code{plotData}: See \code{\link[RNAmodR:plotData]{plotDataByCoord}}.
#' \item \code{plotDataByCoord}: See 
#' \code{\link[RNAmodR:plotData]{plotDataByCoord}}.
#' }
#' 
#' @importMethodsFrom RNAmodR modify aggregate settings plotData 
#' plotDataByCoord
#' 
#' @examples 
#' data(msrms,package="RNAmodR.RiboMethSeq")
#' mrms <- msrms[[1]]
#' settings(mrms)
#' aggregate(mrms)
#' modify(mrms)
#' getDataTrack(mrms, "1", mainScore(mrms))
NULL

.valid_rms_weights <- function(weights){
  if(!is.numeric(weights) | !is.atomic(weights)){
    return(FALSE)
  }
  if((length(weights) %% 2) != 1){
    return(FALSE)
  }
  if(length(weights) < 3L){
    return(FALSE)
  }
  if(weights[ceiling(length(weights)/2)] != 0){
    return(FALSE)
  }
  TRUE
}

.not_logical_operator <- RNAmodR:::.not_logical_operator
.not_integer_bigger_than_10 <- RNAmodR:::.not_integer_bigger_than_10
.not_integer_bigger_than_zero <- RNAmodR:::.not_integer_bigger_than_zero
.not_numeric_between_0_1 <- RNAmodR:::.not_numeric_between_0_1
.not_numeric_bigger_zero <- RNAmodR:::.not_numeric_bigger_zero

.ModRiboMethSeq_settings <- data.frame(
  variable = c("maxLength",
               "minSignal",
               "minScoreA",
               "flankingRegion",
               "minScoreB",
               "minScoreRMS",
               "minScoreMean",
               "flankingRegionMean",
               "weights",
               "scoreOperator"),
  testFUN = c(".not_integer_bigger_than_10",
              ".not_integer_bigger_than_zero",
              ".not_numeric_between_0_1",
              ".not_integer_bigger_than_zero",
              ".not_numeric_bigger_zero",
              ".not_numeric_between_0_1",
              ".not_numeric_between_0_1",
              ".not_integer_bigger_than_zero",
              ".valid_rms_weights",
              ".not_logical_operator"),
  errorValue = c(TRUE,
                 TRUE,
                 TRUE,
                 TRUE,
                 TRUE,
                 TRUE,
                 TRUE,
                 TRUE,
                 FALSE,
                 TRUE),
  errorMessage = c("'maxLength' must be integer with a value higher than 10.",
                   "'minSignal' must be integer with a value higher than 0.",
                   "'minScoreA' must be numeric with a value between 0 and 1.",
                   "'flankingRegion' must be integer with a value higher than 0L.",
                   "'minScoreB' must be numeric and greater then 0.",
                   "'minScoreRMS' must be numeric with a value between 0 and 1.",
                   "'minScoreMean' must be numeric with a value between 0 and 1.",
                   "'flankingRegionMean' must be integer with a value higher than 0L.",
                   "'weights' must be a numeric vector of uneven length. The middle position will be used as the current position.",
                   "'scoreOperator' must be either '|' or '&'."),
  stringsAsFactors = FALSE)

.norm_rms_args <- function(input){
  maxLength <- 50L # for all scores
  minSignal <- 10L # for all scores
  minScoreA <- 0.6 # for score A
  flankingRegion <- 6L # for score A
  minScoreB <- 3.6 # for score B
  minScoreRMS <- 0.75 # for score C/RMS
  minScoreMean <- 0.75 # for ScoreMean
  flankingRegionMean <- 2L # for ScoreMean
  weights <- c(0.9,1,0,1,0.9) # for score B/C/RMS
  scoreOperator <- "&"
  args <- RNAmodR:::.norm_settings(input, .ModRiboMethSeq_settings, maxLength,
                                   minSignal, flankingRegion, minScoreA, 
                                   minScoreB, minScoreRMS, minScoreMean, 
                                   flankingRegionMean, weights, scoreOperator)
  args <- c(RNAmodR:::.norm_Modifier_settings(input),
            args)
  args
}

#' @rdname ModRiboMethSeq-functions
#' @export
setReplaceMethod(f = "settings", 
    signature = signature(x = "ModRiboMethSeq"),
    definition = function(x, value){
        x <- callNextMethod()
        names <- names(value)
        value <- .norm_rms_args(value)
        x <- RNAmodR:::.add_settings_value(x, value, names)
        x
    }
)


# functions --------------------------------------------------------------------

# calculates score A according to Birkedal et al. 2015
# it is simplified to use the mean/sd for the neighboring positions
# and not the left and right mean/sd seperatly
.calculate_ribometh_score_A_c <- function(n,
                                          meanL,
                                          sdL,
                                          meanR,
                                          sdR){
  dividend <- (2 * n  + 1)
  divisor <- (0.5 * abs(meanL - sdL)) + n + (0.5 * abs(meanR - sdR)) + 1
  ans <- 1 - (dividend / divisor)
  ans <- vapply(ans,max,numeric(1),0)
  ans[is.na(ans)] <- 0
  return(ans)
}
.calculate_ribometh_score_A <- compiler::cmpfun(.calculate_ribometh_score_A_c)

# calculates score B according to Birkedal et al. 2015
# it is simplified to use the weighted neighboring positions
# and not the left and right area seperatly
.calculate_ribometh_score_B_c <- function(n,
                                          areaL,
                                          weightsL,
                                          areaR,
                                          weightsR){
  waL <- sum(weightsL * areaL) / sum(weightsL)
  waR <- sum(weightsR * areaR) / sum(weightsR)
  dividend <- abs(n - 0.5 * ( waL + waR ) )
  divisor <- (n + 1)
  ans <- dividend / divisor
  ans[is.na(ans)] <- 0
  return(ans)
}
.calculate_ribometh_score_B <- compiler::cmpfun(.calculate_ribometh_score_B_c)

# calculates score C according to Birkedal et al. 2015
# it is simplified to use the weighted neighboring positions
# and not the left and right area seperatly
.calculate_ribometh_score_meth_c <- function(n,
                                             areaL,
                                             weightsL,
                                             areaR,
                                             weightsR){
  waL <- sum(weightsL * areaL) / sum(weightsL)
  waR <- sum(weightsR * areaR) / sum(weightsR)
  dividend <- n
  divisor <- 0.5 * ( waL + waR )
  ans <- 1 - (dividend / divisor)
  ans <- vapply(ans,max,numeric(1),0)
  ans[is.na(ans)] <- 0
  return(ans)
}
.calculate_ribometh_score_meth <- compiler::cmpfun(.calculate_ribometh_score_meth_c)

# calculates score MAX according to Galvanin et al. 2018
.calculate_ribometh_score_mean_c <- function(n,
                                             mean){
  ans <- 1 - (n / mean)
  ans <- vapply(ans,max,numeric(1),0)
  ans[is.na(ans)] <- 0
  return(ans)
}
.calculate_ribometh_score_mean <- compiler::cmpfun(.calculate_ribometh_score_mean_c)

# calculates score MAX according to Marchand et al. 2016
# not used since no clear description available in the literature
# .calculate_ribometh_score_max_c <- function(n,
#                                              area,
#                                              weights){
#   browser()
# }
# .calculate_ribometh_score_max <- compiler::cmpfun(.calculate_ribometh_score_max_c)


# RiboMeth scores --------------------------------------------------------------

# calculates score A according to Birkedal et al. 2015
.get_score_A <- function(data,
                         countsL,
                         countsR){
  # replicates
  n <- seq_along(data)
  countsMeanL <- IRanges::NumericList(
    lapply(n,
           function(j){
             unlist(lapply(countsL[[j]],
                           mean,
                           na.rm = TRUE))
           }))
  countsSdL <- IRanges::NumericList(
    lapply(n,
           function(j){
             unlist(lapply(countsL[[j]],
                           BiocGenerics::sd,
                           na.rm = TRUE))
           }))
  countsSdL[is.na(countsSdL)] <- 0
  countsMeanR <- IRanges::NumericList(
    lapply(n,
           function(j){
             unlist(lapply(countsR[[j]],
                           mean,
                           na.rm = TRUE))
           }))
  countsSdR <- IRanges::NumericList(
    lapply(n,
           function(j){
             unlist(lapply(countsR[[j]],
                           BiocGenerics::sd,
                           na.rm = TRUE))
           }))
  countsSdR[is.na(countsSdR)] <- 0
  # calc score per replicate
  scoreA <- IRanges::NumericList(mapply(FUN = .calculate_ribometh_score_A,
                                        data,
                                        countsMeanL,
                                        countsSdL,
                                        countsMeanR,
                                        countsSdR))
  return(scoreA)
}

# calculates score B according to Birkedal et al. 2015
.get_score_B <- function(data,
                         countsL,
                         weightsL,
                         countsR,
                         weightsR){
  scoreB <- IRanges::NumericList(mapply(FUN = .calculate_ribometh_score_B,
                                        data,
                                        countsL,
                                        weightsL,
                                        countsR,
                                        weightsR))
  return(scoreB)
}

# calculates score C according to Birkedal et al. 2015
.get_score_meth <- function(data,
                            countsL,
                            weightsL,
                            countsR,
                            weightsR){
  scoreMeth <- IRanges::NumericList(mapply(FUN = .calculate_ribometh_score_meth,
                                           data,
                                           countsL,
                                           weightsL,
                                           countsR,
                                           weightsR))
  return(scoreMeth)
}

# calculates ScoreMean according to Galvanin et al. 2018
.get_score_mean <- function(data,
                            countsL,
                            countsR){
  # replicates
  n <- seq_along(data)
  countsMean <- lapply(n,
                       function(j){
                         pc(countsL[[j]],countsR[[j]])
                       })
  countsMean <- IRanges::NumericList(
    lapply(n,
           function(j){
             unlist(lapply(countsMean[[j]],
                           mean,
                           na.rm = TRUE))
           }))
  # calc score per replicate
  scoreMean <- IRanges::NumericList(mapply(FUN = .calculate_ribometh_score_mean,
                                           data,
                                           countsMean))
  return(scoreMean)
}

# calculates score C according to Marchand et al. 2016
# .get_score_max <- function(data,
#                            countsL,
#                            weightsL,
#                            countsR,
#                            weightsR){
#   browser()
#   scoreMAX <- IRanges::NumericList(mapply(FUN = .calculate_ribometh_score_max,
#                                  data,
#                                  countsL,
#                                  weightsL,
#                                  countsR,
#                                  weightsR))
#   return(scoreMAX)
# }

.norm_rms_weights <- function(x){
  weights <- settings(x,"weights")
  if(is.null(names(weights))){
    names(weights) <- seq_along(weights) - ((length(weights) / 2) + 0.5)
  }
  names <- as.integer(names(weights))
  if(any(is.na(names))){
    stop("If 'weights' is named, all names must be coercible to integer ",
         "values.",
         call. = FALSE)
  }
  if(length(which(names == 0L)) != 1){
    stop("If 'weights' is named, exactly one name must be '0'",
         call. = FALSE)
  }
  weights
}

.aggregate_rms <- function(x){
  # parameter data
  weights <- .norm_rms_weights(x)
  weightPositions <- as.integer(names(weights))
  # ToOo check for continuity
  if(length(weights) != length(weightPositions)){
    stop("Something went wrong.")
  }
  # get the means. the sds arecurrently disregarded for this analysis
  mod <- aggregate(sequenceData(x), condition = "Treated")
  means <- mod[,which(grepl("mean", colnames(unlist(mod))))]
  # set up variables
  n <- length(mod)
  nV <- seq_len(n)
  lengths <- lengths(mod)
  pos <- lapply(lengths,seq_len)
  flankingRegion <- settings(x,"flankingRegion")
  flankingRegionMean <- settings(x,"flankingRegionMean")
  positionsR <- seq_len(flankingRegion)
  positionsL <- rev(positionsR) * -1
  positionsRMean <- seq_len(flankingRegionMean)
  positionsLMean <- rev(positionsRMean) * -1
  weightPositionsL <- weightPositions[weightPositions < 0]
  weightPositionsR <- weightPositions[weightPositions > 0]
  weightPositionsC <- which(weightPositions == 0)
  # subset to neightbouring positions based on the size of flankingRegion
  neighborCountsLFR <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- positionsL + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  neighborCountsRFR <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- positionsR + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  
  # subset to neightbouring positions based on the size of flankingRegionMean
  neighborCountsLFRMean <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- positionsLMean + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  neighborCountsRFRMean <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- positionsRMean + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  # subset to neightbouring positions based on the size of the weights
  neighborCountsL <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- weightPositionsL + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  neighborCountsR <- 
    lapply(nV,
           function(j){
             IRanges::IntegerList(lapply(pos[[j]],
                                         function(k){
                                           f <- weightPositionsR + k
                                           ans <- means[[j]][f[f > 0]]
                                           ans <- ans[!is.na(ans)]
                                           ans
                                         }))
           })
  # create list of weights vector alongside the neighbor counts
  weightsListL <- 
    lapply(nV,
           function(j){
             IRanges::NumericList(mapply(
               function(k,l){
                 f <- weightPositionsL + k
                 ans <- weights[which(f > 0 & f <= l)]
                 ans
               },
               pos[[j]],
               MoreArgs = list(l = lengths[j])))
           })
  weightsListR <- 
    lapply(nV,
           function(j){
             IRanges::NumericList(mapply(
               function(k,l,of){
                 f <- weightPositionsR + k
                 f <- which(f > 0 & f <= l) + of
                 ans <- weights[f]
                 ans
               },
               pos[[j]],
               MoreArgs = list(l = lengths[j],
                               of = weightPositionsC)))
           })
  # calculate the actual scores
  scoreA <- .get_score_A(means,
                         neighborCountsLFR,
                         neighborCountsRFR)
  scoreB <- .get_score_B(means,
                         neighborCountsL,
                         weightsListL,
                         neighborCountsR,
                         weightsListR)
  scoreRMS <- .get_score_meth(means,
                              neighborCountsL,
                              weightsListL,
                              neighborCountsR,
                              weightsListR)
  scoreMean <- .get_score_mean(means,
                               neighborCountsLFRMean,
                               neighborCountsRFRMean)
  # scoreMAX <- .get_score_max()
  ans <- S4Vectors::DataFrame(ends = unlist(means),
                              scoreA = unlist(scoreA),
                              scoreB = unlist(scoreB),
                              scoreRMS = unlist(scoreRMS),
                              scoreMean = unlist(scoreMean),
                              row.names = NULL)
  ans <- relist(ans, IRanges::PartitioningByEnd(mod))
  rownames(ans) <- IRanges::CharacterList(RNAmodR:::.seqs_rl_strand(ranges(x)))
  ans
}

#' @rdname ModRiboMethSeq-functions
#' @export
setMethod(
  f = "aggregateData", 
  signature = signature(x = "ModRiboMethSeq"),
  definition = 
    function(x){
      .aggregate_rms(x)
    }
)

.get_rms_scores <- function(data){
  list(score = data$scoreRMS,
       scoreA = data$scoreA,
       scoreB = data$scoreB,
       scoreMean = data$scoreMean)
}

.find_rms <- function(x){
  if(!hasAggregateData(x)){
    stop("Something went wrong.")
  }
  letters <- IRanges::CharacterList(strsplit(as.character(sequences(x)),""))
  grl <- ranges(x)
  # get the aggregate data
  mod <- getAggregateData(x)
  # setup args
  minSignal <- settings(x,"minSignal")
  minScoreA <- settings(x,"minScoreA")
  minScoreB <- settings(x,"minScoreB")
  minScoreRMS <- settings(x,"minScoreRMS")
  minScoreMean <- settings(x,"minScoreMean")
  scoreOperator <- settings(x,"scoreOperator")
  # find modifications
  modifications <- mapply(
    function(m,l,r){
      m <- m[!is.na(m$scoreA) &
               !is.na(m$scoreB) &
               !is.na(m$scoreRMS) &
               !is.na(m$scoreMean),,drop=FALSE]
      if(nrow(m) == 0L) return(NULL)
      m <- m[m$ends >= minSignal,,drop=FALSE]
      if(nrow(m) == 0L) return(NULL)
      logical <- data.frame(m$scoreA >= minScoreA,
                            m$scoreB >= minScoreB,
                            m$scoreRMS >= minScoreRMS,
                            m$scoreMean >= minScoreMean)
      m <- m[mapply(Reduce,
                    rep(scoreOperator,nrow(m)),
                    lapply(seq_len(nrow(m)),function(i){logical[i,]}),
                    SIMPLIFY = TRUE),,drop=FALSE]
      if(nrow(m) == 0L) return(NULL)
      ans <- RNAmodR:::constructModRanges(
        r,
        m,
        modType = "Am",
        scoreFun = RNAmodR.RiboMethSeq:::.get_rms_scores,
        source = "RNAmodR.RiboMethSeq",
        type = "RNAMOD")
      ans$mod <- paste0(l[BiocGenerics::start(ans)],"m")
      ans
    },
    mod,
    letters,
    grl)
  f <- !vapply(modifications,
               is.null,
               logical(1))
  modifications <- mapply(
    function(m,name){
      m$Parent <- rep(name,length(m))
      m
    },
    modifications[f],
    names(grl)[f],
    SIMPLIFY = FALSE)
  modifications <- GenomicRanges::GRangesList(modifications)
  unname(unlist(modifications))
}

#' @rdname ModRiboMethSeq-functions
#' @export
setMethod("findMod",
          signature = c(x = "ModRiboMethSeq"),
          function(x){
            .find_rms(x)
          }
)


# ModSetRiboMethSeq ------------------------------------------------------------

#' @rdname ModRiboMethSeq
#' @export
setClass("ModSetRiboMethSeq",
         contains = "ModifierSet",
         prototype = list(elementType = "ModRiboMethSeq"))

#' @rdname ModRiboMethSeq
#' @export
ModSetRiboMethSeq <- function(x, annotation = NA, sequences = NA, seqinfo = NA,
                              ...){
  RNAmodR::ModifierSet("ModRiboMethSeq", x, annotation = annotation,
                        sequences = sequences, seqinfo = seqinfo, ...)
}

context("RiboMethSeq")
# .get_heatmap_data
test_that("RiboMethSeq:",{
  # weight validation
  expect_false(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1,1,1)))
  expect_true(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1,0,1)))
  expect_false(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1,1,0,1)))
  expect_false(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1,0)))
  expect_false(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1)))
  expect_true(RNAmodR.RiboMethSeq:::.valid_rms_weights(c(1,1,0,1,1)))
  # argument normalization
  input <- list()
  actual <- RNAmodR.RiboMethSeq:::.norm_rms_args(input)
  expect_type(actual,"list")
  expect_named(actual,c("minCoverage",
                        "minReplicate",
                        "find.mod",
                        "maxLength",
                        "minSignal",
                        "flankingRegion",
                        "minScoreA",
                        "minScoreB",
                        "minScoreRMS",
                        "minScoreMean",
                        "flankingRegionMean",
                        "weights",
                        "scoreOperator"))
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(weights = c(1,1,0,1))))
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minSignal = 10)))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minSignal = 10L)),
               actual)
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreA = 2L)))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreA = 0.6)),
               actual)
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(flankingRegion = 2.5)))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(flankingRegion = 6L)),
               actual)
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreB = "a")))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreB = 3.6)),
               actual)
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreRMS = 2L)))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(minScoreRMS = 0.75)),
               actual)
  expect_error(RNAmodR.RiboMethSeq:::.norm_rms_args(list(scoreOperator = 2L)))
  expect_equal(RNAmodR.RiboMethSeq:::.norm_rms_args(list(scoreOperator = "&")),
               actual)
  
  data <- data.frame(ends = "1", scoreRMS = "a", scoreA = "b", scoreB = "c",
                     scoreMean = "d",
                     stringsAsFactors = FALSE)
  actual <- RNAmodR.RiboMethSeq:::.get_rms_scores(data)
  expect_type(actual,"list")
  expect_named(actual,c("score","scoreA","scoreB","scoreMean"))
  # settings
  data("msrms", package = "RNAmodR.RiboMethSeq")
  expect_type(settings(msrms),"list")
  expect_type(settings(msrms[[1]]),"list")
  expect_error(settings(msrms[[1]]) <- 1,
               "'value' has to be a named.")
  expect_error(settings(msrms[[1]]) <- c(1),
               "'value' has to be a named.")
  # settings(msrms[[1]]) <- c(minCoverage = 11L)
  # expect_equal(settings(msrms[[1]])$minCoverage, 11L)
  # # aggregate Data
  expect_s4_class(sequenceData(msrms[[1]]), "ProtectedEndSequenceData")
  mod <- aggregate(sequenceData(msrms[[1]]), condition = "Treated")
  expect_named(mod)
  expect_s4_class(mod,"CompressedSplitDFrameList")
  expect_equal(colnames(mod[[1L]]),c("means.treated","sds.treated"))
  expect_equal(mod[[1L]][1,1], 14152)
  #
  actual <- RNAmodR.RiboMethSeq:::.aggregate_rms(msrms[[1]]) 
  expect_named(actual)
  expect_s4_class(actual,"CompressedSplitDFrameList")
  expect_equivalent(actual[[1]][1,3], 0)
  expect_equivalent(actual[[1]][2,3], 0.75416916223702946)
  expect_equal(colnames(actual[[1]]),c("ends","scoreA","scoreB","scoreRMS",
                                       "scoreMean"))
  # findMod
  actual <- findMod(msrms[[1]])
  expect_s4_class(actual,"GRanges")
  expect_length(actual,0)
  expect_equal(dim(mcols(actual)),c(0,0))
  actual <- findMod(msrms[[2]])
  expect_s4_class(actual,"GRanges")
  expect_length(actual,1)
  expect_equal(colnames(mcols(actual)),c("mod","source","type","score",
                                         "scoreA","scoreB","scoreMean",
                                         "Parent"))
  expect_equal(unique(mcols(actual)$mod),c("Um"))
  # show
  # expect_output(expect_warning(show(msrms),
  # "Settings were changed after data aggregation or"))
  # expect_warning(modifications(msrms),
  # "Settings were changed after data aggregation or")
  expect_true(all(modifications(msrms)[[1]] == actual))
  # plotting
  expect_error(RNAmodR.RiboMethSeq:::.norm_viz_mod_rms_args(list(), "1"),
               "Type '1' is not valid")
  actual <- RNAmodR.RiboMethSeq:::.norm_viz_mod_rms_args(list(), "scoreA")
  expect_type(actual,"list")
  expect_named(actual,c("type","colour"))
  expect_equal(actual[["type"]],"scoreA")
  actual <- RNAmodR.RiboMethSeq:::.norm_viz_mod_rms_args(list(), "scoreB")
  expect_equal(actual[["type"]],"scoreB")
  actual <- RNAmodR.RiboMethSeq:::.norm_viz_mod_rms_args(list(), "ends")
  expect_equal(actual[["type"]],"ends")
  # getDataTrack
  expect_error(getDataTrack(msrms[[1]]),
               'argument "type" is missing, with no default')
  expect_error(getDataTrack(msrms[[1]],type="score"),
               "Type 'score' is not valid")
  expect_error(getDataTrack(msrms[[1]],type="scoreB"),
               'argument "name" is missing')
  actual <- getDataTrack(msrms[[1]],name="1",type="scoreB")
  expect_type(actual,"list")
  expect_named(actual,"scoreB")
  expect_s4_class(actual[[1]],"DataTrack")
  # plotData
  actual <- plotData(msrms[[1]],name="1",type="scoreB")
  expect_type(actual,"list")
  expect_named(actual,c("Score B","SequenceTrack","titles"))
  expect_s4_class(actual[[1]],"DataTrack")
  expect_s4_class(actual[[2]],"SequenceRNAStringSetTrack")
  expect_s4_class(actual[[3]],"ImageMap")
  actual <- plotData(msrms,name="1",type="scoreB")
  expect_type(actual,"list")
  expect_s4_class(actual[[1]],"DataTrack")
  expect_s4_class(actual[[2]],"DataTrack")
  expect_s4_class(actual[[3]],"SequenceRNAStringSetTrack")
  expect_s4_class(actual[[4]],"ImageMap")
})

#' @title RNAmodR.RiboMethSeq
#' 
#' @author Felix G M Ernst [aut], Denis L J Lafontaine [fnd]
#' 
#' @description
#' `RNAmodR.RiboMethSeq` implements the detection of 2'-O methylations from 
#' RiboMethSeq data using the workflow and class the package `RNAmodR` provides.
#' 
#' @seealso Further details are described in the man pages of the 
#' \code{\link[RNAmodR:Modifier-class]{Modifier}} object and the vignettes.
#'
#' @name RNAmodR.RiboMethSeq
NULL

#' @keywords internal
"_PACKAGE"

#' @import methods
#' @import RNAmodR
#' @import S4Vectors
#' @import BiocGenerics
#' @import IRanges
#' @import GenomicRanges
#' @import Gviz
NULL
requireNamespace("RNAmodR")

#' @name RNAmodR.RiboMethSeq-datasets
#' @title Example data in the RNAmodR.RiboMethSeq package
#' @description 
#' This contains an example ModifierSet object of type ModSetRiboMethSeq
#' @docType data
#' 
#' @format a \code{ModSetRiboMethSeq} instance
#' @keywords datasets
#' @usage data(msrms)
"msrms"

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown(css.files = c('custom.css'))

## ----echo = FALSE-------------------------------------------------------------
suppressPackageStartupMessages({
  library(rtracklayer)
  library(GenomicRanges)
  library(RNAmodR.RiboMethSeq)
  library(RNAmodR.Data)
})

## ----eval = FALSE-------------------------------------------------------------
# library(rtracklayer)
# library(GenomicRanges)
# library(RNAmodR.RiboMethSeq)
# library(RNAmodR.Data)

## ----message=FALSE, results='hide'--------------------------------------------
annotation <- GFF3File(RNAmodR.Data.example.RMS.gff3())
sequences <- RNAmodR.Data.example.RMS.fasta()
files <- list("Sample1" = c(treated = RNAmodR.Data.example.RMS.1()),
              "Sample2" = c(treated = RNAmodR.Data.example.RMS.2()))

## -----------------------------------------------------------------------------
msrms <- ModSetRiboMethSeq(files, annotation = annotation, sequences = sequences)
msrms

## -----------------------------------------------------------------------------
table <- read.csv2(RNAmodR.Data.snoRNAdb(), stringsAsFactors = FALSE)
table <- table[table$hgnc_id == "53533",] # Subset to RNA5.8S
# keep only the current coordinates
table <- table[,1L:7L]
snoRNAdb <- GRanges(seqnames = "chr1",
              ranges = IRanges(start = table$position,
                               width = 1),
              strand = "+",
              type = "RNAMOD",
              mod = table$modification,
              Parent = "1", #this is the transcript id
              Activity = IRanges::CharacterList(strsplit(table$guide,",")))
coord <- split(snoRNAdb,snoRNAdb$Parent)

## -----------------------------------------------------------------------------
ranges(msrms)
alias <- data.frame(tx_id = "1", name = "5.8S rRNA", stringsAsFactors = FALSE)

## ----plot1, fig.cap="Heatmap showing RiboMethSeq scores for 2'-O methylated positions on the 5.8S rRNA."----
plotCompareByCoord(msrms[c(2L,1L)], coord, alias = alias)

## ----plot2, fig.cap="RiboMethSeq scores around Um(14) on 5.8S rRNA.", fig.asp=1----
singleCoord <- coord[[1L]][1L,]
plotDataByCoord(msrms, singleCoord)

## ----plot3, fig.cap="RiboMethSeq scores around Um(14) on 5.8S rRNA. Sequence data is shown by setting `showSequenceData = TRUE`.", fig.asp=1----
singleCoord <- coord[[1L]][1L,]
plotDataByCoord(msrms, singleCoord, showSequenceData = TRUE)

## ----plot4, fig.cap="TPR versus FPR plot.", fig.asp=1-------------------------
plotROC(msrms,coord)

## ----settings-----------------------------------------------------------------
settings(msrms) <- list(minScoreMean = 0.7)
msrms

## ----udpate-------------------------------------------------------------------
msrms2 <- modify(msrms,force = TRUE)

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

context("RiboMethSeq score A")
# .get_heatmap_data
test_that("RiboMethSeq score A:",{
  # score A
  # .calculate_ribometh_score_A
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(1,1,0,1,0)
  expect_equal(actual,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(100000,1,0,1,0)
  expect_equal(actual,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(1,10,0,10,0)
  expect_equal(actual,0.75)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(1,10,1,10,1)
  expect_equal(round(actual,7),0.7272727)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(1,100,0,100,0)
  expect_equal(round(actual,7),0.9705882)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(10,100,0,100,0)
  expect_equal(round(actual,7),0.8108108)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_A(10,100,10,100,10)
  expect_equal(round(actual,7),0.7920792)
})

context("RiboMethSeq score B")
# .get_heatmap_data
test_that("RiboMethSeq score B:",{
  # score B
  # .calculate_ribometh_score_B
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,1,0,1,0)
  expect_equal(actual,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,10,1,10,1)
  expect_equal(actual,4.5)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,100,1,100,1)
  expect_equal(actual,49.5)
  area <- c(100,50,200)
  weights <- c(1,1,1)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,area,weights,area,weights)
  expect_equal(round(actual,2),57.83)
  weights <- c(1,0.75,0.5)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,area,weights,area,weights)
  expect_equal(round(actual,2),52.28)
  weights <- c(1,0.5,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_B(1,area,weights,area,weights)
  expect_equal(round(actual,2),41.17)
})

context("RiboMethSeq score RMS")
# .get_heatmap_data
test_that("RiboMethSeq score RMS:",{
  # score RMS
  # .calculate_ribometh_score_meth
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,1,0,1,0)
  expect_equal(actual,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,10,1,10,1)
  expect_equal(actual,0.9)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,100,1,100,1)
  expect_equal(actual,0.99)
  area <- c(100,50,200)
  weights <- c(1,1,1)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,area,weights,area,weights)
  expect_equal(round(actual,7),0.9914286)
  weights <- c(1,0.75,0.5)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,area,weights,area,weights)
  expect_equal(round(actual,7),0.9905263)
  weights <- c(1,0.5,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_meth(1,area,weights,area,weights)
  expect_equal(round(actual,7),0.988)
})


context("RiboMethSeq scoreMean")
# .get_heatmap_data
test_that("RiboMethSeq scoreMean:",{
  # score RMS
  # .calculate_ribometh_score_meth
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_mean(1,1)
  expect_equal(actual,0)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_mean(1,10)
  expect_equal(actual,0.9)
  actual <- RNAmodR.RiboMethSeq:::.calculate_ribometh_score_mean(1,100)
  expect_equal(actual,0.99)
})

# context("RiboMethSeq score MAX")
# # .get_heatmap_data
# test_that("RiboMethSeq score MAX:",{
#             # score MAX
#             # .calculate_ribometh_score_max
#           })

---
title: 'RNAmodR: RiboMethSeq'
author: "Felix G.M. Ernst and Denis L.J. Lafontaine"
date: "`r Sys.Date()`"
abstract: >
  Detection of 2'-O methylations by RiboMethSeq
output:
  BiocStyle::html_document:
    toc: true
    toc_float: true
    df_print: paged
vignette: >
  %\VignetteIndexEntry{RNAmodR.RiboMethSeq}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
bibliography: references.bib
---

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown(css.files = c('custom.css'))
```

# Introduction

Among the various post-transcriptional RNA modifications, 2'-O methylations are
commonly found in rRNA and tRNA. They promote the endo conformation of the
ribose and confere resistance to alkaline degradation by preventing a
nucleophilic attack on the 3'-phosphate especially in flexible RNA, which is
fascilitated by high pH conditions. This property can be queried using a method
called RiboMethSeq [[@Birkedal.2015]](#References) for which RNA is treated in
alkaline conditions and RNA fragments are used to prepare a sequencing library
[[@Marchand.2017]](#References).

At position containing a 2'-O methylations, read ends are less frequent, which
is used to detect and score the 2'-O methylations.

The `ModRiboMethSeq` class uses the the `ProtectedEndSequenceData` class to
store and aggregate data along the transcripts. The calculated scores follow the
nomenclature of [[@Birkedal.2015;@Galvanin.2019]](#References) with the names
`scoreRMS` (default), `scoreA`, `scoreB` and `scoreMean`.

```{r, echo = FALSE}
suppressPackageStartupMessages({
  library(rtracklayer)
  library(GenomicRanges)
  library(RNAmodR.RiboMethSeq)
  library(RNAmodR.Data)
})
```
```{r, eval = FALSE}
library(rtracklayer)
library(GenomicRanges)
library(RNAmodR.RiboMethSeq)
library(RNAmodR.Data)
```

# Example workflow

The example workflow is limited to two 2'-O methylated position on 5.8S rRNA,
since the size of the raw data is limited. For annotation data either a gff file
or a `TxDb` object and for sequence data a fasta file or a `BSgenome` object can
be used. The data is provided as bam files.

```{r, message=FALSE, results='hide'}
annotation <- GFF3File(RNAmodR.Data.example.RMS.gff3())
sequences <- RNAmodR.Data.example.RMS.fasta()
files <- list("Sample1" = c(treated = RNAmodR.Data.example.RMS.1()),
              "Sample2" = c(treated = RNAmodR.Data.example.RMS.2()))
```

# Analysis of data

The analysis is triggered by the construction of a `ModSetRiboMethSeq` object.
Internally parallelization is used via the `BiocParallel` package, which would
allow optimization depending on number/size of input files (number of samples,
number of replicates, number of transcripts, etc).

```{r}
msrms <- ModSetRiboMethSeq(files, annotation = annotation, sequences = sequences)
msrms
```

# Visualizing the results

To compare samples, we need to know, which positions should be part of the
comparison. This can either be done by aggregating the detect over all samples
and use the union or intersect or by using publish data. We want to assemble
a GRanges object from the latter by utilising the infomation from the snoRNAdb
[[@Lestrade.2006]](#References).

In this specific example only information for the 5.8S RNA is used, since the
example data would be to big otherwise. The information regarding the parent and
seqname must match the information used as the annotation data. Check that it
matches the output of `ranges()` on a `SequenceData`, `Modifier` oder
`ModifierSet` object.

```{r}
table <- read.csv2(RNAmodR.Data.snoRNAdb(), stringsAsFactors = FALSE)
table <- table[table$hgnc_id == "53533",] # Subset to RNA5.8S
# keep only the current coordinates
table <- table[,1L:7L]
snoRNAdb <- GRanges(seqnames = "chr1",
              ranges = IRanges(start = table$position,
                               width = 1),
              strand = "+",
              type = "RNAMOD",
              mod = table$modification,
              Parent = "1", #this is the transcript id
              Activity = IRanges::CharacterList(strsplit(table$guide,",")))
coord <- split(snoRNAdb,snoRNAdb$Parent)
```

In addition to the coordinates of published, we also want to include more 
meaningful names for the transcripts. For this we provide a `data.frame` with
two columns, `tx_id` and `name`. All values in the first column have to match
transcript IDs.

```{r}
ranges(msrms)
alias <- data.frame(tx_id = "1", name = "5.8S rRNA", stringsAsFactors = FALSE)
```

```{r plot1, fig.cap="Heatmap showing RiboMethSeq scores for 2'-O methylated positions on the 5.8S rRNA."}
plotCompareByCoord(msrms[c(2L,1L)], coord, alias = alias)
```

Results can also be compared on a sequence level, by selecting specific 
coordinates to compare.

```{r, plot2, fig.cap="RiboMethSeq scores around Um(14) on 5.8S rRNA.", fig.asp=1}
singleCoord <- coord[[1L]][1L,]
plotDataByCoord(msrms, singleCoord)
```

By default only the RiboMethSeq score and the ScoreMean are shown. The raw 
sequence data can be inspected as well

```{r, plot3, fig.cap="RiboMethSeq scores around Um(14) on 5.8S rRNA. Sequence data is shown by setting `showSequenceData = TRUE`.", fig.asp=1}
singleCoord <- coord[[1L]][1L,]
plotDataByCoord(msrms, singleCoord, showSequenceData = TRUE)
```

# Performance

To access the performance of the method in combination with samples used, use
the `plotROC` function.

```{r plot4, fig.cap="TPR versus FPR plot.", fig.asp=1}
plotROC(msrms,coord)
```

The example given here should be regarded as a proof of concept. Based on the
results, minimal scores for calling modified positions can be adjusted to the
individual requirements.

```{r settings}
settings(msrms) <- list(minScoreMean = 0.7)
msrms
```

As the warning suggested, after modifying the settings the results should be 
updated by running `modify(x,force = TRUE)`.

```{r udpate}
msrms2 <- modify(msrms,force = TRUE)
```

# Session info

```{r, sessioninfo}
sessionInfo()
```

<a name="References"></a>

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Modifier-RiboMethSeq-class.R,
%   R/Modifier-RiboMethSeq-viz.R
\name{ModRiboMethSeq-functions}
\alias{ModRiboMethSeq-functions}
\alias{aggregate}
\alias{modify}
\alias{settings}
\alias{plotData}
\alias{plotDataByCoord}
\alias{settings<-,ModRiboMethSeq-method}
\alias{aggregateData,ModRiboMethSeq-method}
\alias{findMod,ModRiboMethSeq-method}
\alias{getDataTrack,ModRiboMethSeq-method}
\alias{plotDataByCoord,ModRiboMethSeq,GRanges-method}
\alias{plotData,ModRiboMethSeq-method}
\alias{plotDataByCoord,ModSetRiboMethSeq,GRanges-method}
\alias{plotData,ModSetRiboMethSeq-method}
\title{Functions for ModRiboMethSeq}
\usage{
\S4method{settings}{ModRiboMethSeq}(x) <- value

\S4method{aggregateData}{ModRiboMethSeq}(x)

\S4method{findMod}{ModRiboMethSeq}(x)

\S4method{getDataTrack}{ModRiboMethSeq}(x, name, type, ...)

\S4method{plotDataByCoord}{ModRiboMethSeq,GRanges}(
  x,
  coord,
  type = c("ends", "scoreA", "scoreB", "scoreRMS", "scoreMean"),
  window.size = 15L,
  ...
)

\S4method{plotData}{ModRiboMethSeq}(
  x,
  name,
  from = 1L,
  to = 30L,
  type = c("ends", "scoreA", "scoreB", "scoreRMS", "scoreMean"),
  ...
)

\S4method{plotDataByCoord}{ModSetRiboMethSeq,GRanges}(
  x,
  coord,
  type = c("scoreRMS", "ends", "scoreA", "scoreB", "scoreMean"),
  window.size = 15L,
  ...
)

\S4method{plotData}{ModSetRiboMethSeq}(
  x,
  name,
  from = 1L,
  to = 30L,
  type = c("scoreRMS", "ends", "scoreA", "scoreB", "scoreMean"),
  ...
)
}
\arguments{
\item{x}{a \code{\link[RNAmodR:Modifier-class]{Modifier}} or a
\code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} object. For more
details see also the man pages for the functions mentioned below.}

\item{value}{See \code{\link[RNAmodR:Modifier-class]{settings}}}

\item{coord, name, from, to, type, window.size, ...}{See 
\code{\link[RNAmodR:plotData]{plotData}}}
}
\value{
\itemize{
\item \code{settings}: See \code{\link[RNAmodR:Modifier-functions]{settings}}.
\item \code{aggregate}: See \code{\link[RNAmodR:aggregate]{aggregate}}.
\item \code{modify}: See \code{\link[RNAmodR:modify]{modify}}.
\item \code{getDataTrack}: a list of 
\code{\link[Gviz:DataTrack-class]{DataTrack}} object.
\item \code{plotData}: See \code{\link[RNAmodR:plotData]{plotDataByCoord}}.
\item \code{plotDataByCoord}: See 
\code{\link[RNAmodR:plotData]{plotDataByCoord}}.
}
}
\description{
All of the functions of \code{\link[RNAmodR:Modifier-class]{Modifier}} and
the \code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} classes are
inherited by the \code{ModRiboMethSeq} and \code{ModSetRiboMethSeq} classes.
}
\details{
\code{ModRiboMethSeq} specific arguments for 
\code{\link[RNAmodR:plotData]{plotData}}:
\itemize{
\item \code{colour} - a named character vector of \code{length = 4} 
for the colours of the individual histograms. The names are expected to be 
\code{c("ends","scoreA","scoreB","scoreRMS","scoreMean")}.
}
}
\examples{
data(msrms,package="RNAmodR.RiboMethSeq")
mrms <- msrms[[1]]
settings(mrms)
aggregate(mrms)
modify(mrms)
getDataTrack(mrms, "1", mainScore(mrms))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmodR.RiboMethSeq.R
\docType{package}
\name{RNAmodR.RiboMethSeq-package}
\alias{RNAmodR.RiboMethSeq-package}
\title{RNAmodR.RiboMethSeq: Detection of 2'-O methylations by RiboMethSeq}
\description{
RNAmodR.RiboMethSeq implements the detection of 2'-O methylations on RNA from experimental data generated with the RiboMethSeq protocol. The package builds on the core functionality of the RNAmodR package to detect specific patterns of the modifications in high throughput sequencing data.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/FelixErnst/RNAmodR.RiboMethSeq}
  \item Report bugs at \url{https://github.com/FelixErnst/RNAmodR.RiboMethSeq/issues}
}

}
\author{
\strong{Maintainer}: Felix G.M. Ernst \email{felix.gm.ernst@outlook.com} (\href{https://orcid.org/0000-0001-5064-0928}{ORCID})

Other contributors:
\itemize{
  \item Denis L.J. Lafontaine \email{denis.lafontaine@ulb.ac.be} [contributor, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Modifier-RiboMethSeq-class.R
\docType{class}
\name{ModRiboMethSeq}
\alias{ModRiboMethSeq}
\alias{RiboMethSeq}
\alias{ModSetRiboMethSeq}
\alias{ModRiboMethSeq-class}
\alias{ModSetRiboMethSeq-class}
\title{ModRiboMethSeq class to analyze RiboMethSeq data}
\usage{
ModRiboMethSeq(x, annotation = NA, sequences = NA, seqinfo = NA, ...)

ModSetRiboMethSeq(x, annotation = NA, sequences = NA, seqinfo = NA, ...)
}
\arguments{
\item{x}{the input which can be of the different types depending on whether
a \code{ModRiboMethSeq} or a \code{ModSetRiboMethSeq} object is to be 
constructed. For more information have a look at the documentation of
the \code{\link[RNAmodR:Modifier-class]{Modifier}} and 
\code{\link[RNAmodR:ModifierSet-class]{ModifierSet}} classes.}

\item{annotation}{annotation data, which must match the information contained
in the BAM files. This is parameter is only required if \code{x} if not a 
\code{Modifier} object.}

\item{sequences}{sequences matching the target sequences the reads were 
mapped onto. This must match the information contained in the BAM files. This
is parameter is only required if \code{x} if not a \code{Modifier} object.}

\item{seqinfo}{An optional \code{\link[Seqinfo:Seqinfo-class]{Seqinfo}} 
argument or character vector, which can be coerced to one, to subset the 
sequences to be analyzed on a per chromosome basis.}

\item{...}{Optional arguments overwriting default values, which are
\itemize{
\item weights: The weights used for calculating the scores B and RMS 
(default: \code{weights = c(0.9,1,0,1,0.9)}).
\item flankingRegion: The size of the flanking region used for calculation 
of score A as an integer value (default: \code{flankingRegion = 6L}).
\item minSignal: The minimal signal at the position as integer value 
(default: \code{minSignal = 10L}). If the reaction is very specific a lower
value and even 0L may need to be used.
\item minScoreA: minimum for score A to identify 2'-O methylated positions 
de novo (default: \code{minScoreA = 0.6}).
\item minScoreB: minimum for score B to identify 2'-O methylated positions 
de novo (default: \code{minScoreB = 3.0}).
\item minScoreRMS: minimum for score RMS to identify 2'-O methylated 
positions de novo (default: \code{minScoreRMS = 0.75}).
\item minScoreMean: minimum for ScoreMean to identify 2'-O methylated 
positions de novo (default: \code{minScoreMean = 0.75}).
\item flankingRegionMean: The size of the flanking region used for 
calculation of ScoreMean as an integer value (default: 
\code{flankingRegionMean = 2L}).
\item scoreOperator: how the minimal score should be used as logical 
operator. "&" requires all minimal values to be exceeded, whereas "|" detects
positions, if at least one minimal values is exceeded (default: 
\code{scoreOperator = "&"}).
\item maxLength: The default read length. Reads with this length or longer
are discarded, since they represent non-fragmented reads. This might need to
be adjusted for individual samples depending on the experimental conditions.
This is argument is passed on to 
\code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}
(default: \code{maxLength = 50L}).
\item other arguments which are passed on to 
\code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}.
}
To disable minimal values for modification calling, set them to \code{0}.
It is not advised to set them all to \code{0}.}
}
\value{
a \code{ModRiboMethSeq} or \code{ModSetRiboMethSeq} object
}
\description{
Among the various post-transcriptional RNA modifications, 2'-O methylations
are quite common in rRNA and tRNA. They confere resistance to alkaline 
degradation by preventing a nucleophilic attack on the 3'-phosphate 
especially in flexible RNA, which is fascilitated by high pH conditions.
This property can be queried using a method called RiboMethSeq (Birkedahl et 
al. 2015, Marchand et al. 2017) for which RNA is treated in alkaline 
conditions and RNA fragments are used to prepare a sequencing library.

At position containing a 2'-O methylations, read ends are less frequent, 
which is used to detect and score the2'-O methylations.

\code{dataType} is \code{"ProtectedEndSequenceData"}:

The \code{ModRiboMethSeq} class uses the the 
\code{\link[RNAmodR:ProtectedEndSequenceData-class]{ProtectedEndSequenceData}}
class to store and aggregate data along the transcripts. The calculated 
scores follow the nomenclature of Birkedahl et al. (2015) with the names
\code{scoreRMS} (default), \code{scoreA}, \code{scoreB} and \code{scoreMean}.

The ScoreMax as described by Marchand et al. (2017) are not implemented, 
yet, since an unambigeous description is not available from the literature.

The ScoreMean as described by Galvanin et al. (2018) is implemented. However,
use with caution, since the description is not unambigeous. Currently it is
calculated as as: 1 - (n / mean(areaL + areaR)). (n: counts at position, 
areaL: counts from x position upstream, areaR: counts from x position 
downstream)

Only samples named \code{treated} are used for this analysis. Normalization 
to untreated samples is currently not used.

The \code{ModRiboMethSeq5} class can be used as well. However, as 
\code{SequenceData} the 
\code{\link[RNAmodR:EndSequenceData-class]{End5SequenceData}} is employed using
only the 5'-end positions of reads.
}
\examples{
library(RNAmodR.Data)
library(rtracklayer)
annotation <- GFF3File(RNAmodR.Data.example.RMS.gff3())
sequences <- RNAmodR.Data.example.RMS.fasta()
files <- list("Sample1" = c(treated = RNAmodR.Data.example.RMS.1()),
              "Sample2" = c(treated = RNAmodR.Data.example.RMS.1()))
# Creating a Modifier object of type ModRiboMethSeq
mrms <- ModRiboMethSeq(files[[1]], annotation = annotation, sequences = sequences)
# Creating a ModifierSet object of type ModSetRiboMethSeq
msrms <- ModSetRiboMethSeq(files, annotation = annotation, sequences = sequences)
}
\references{
- Birkedal U, Christensen-Dalsgaard M, Krogh N, Sabarinathan R, Gorodkin J, 
Nielsen H (2015): "Profiling of ribose methylations in RNA by high-throughput
sequencing." Angewandte Chemie (International ed. in English) 54 (2), 
P. 451–455. DOI: 
\href{https://doi.org/10.1002/anie.201408362}{10.1002/anie.201408362}.

- Marchand V, Ayadi L, El Hajj A, Blanloeil-Oillo F, Helm M, Motorin Y 
(2017): "High-Throughput Mapping of 2'-O-Me Residues in RNA Using 
Next-Generation Sequencing (Illumina RiboMethSeq Protocol)." Methods in 
molecular biology (Clifton, N.J.) 1562, P. 171–187. DOI: 
\href{https://doi.org/10.1007/978-1-4939-6807-7_12}{10.1007/978-1-4939-6807-7_12}.

- Galvanin A, Ayadi L, Helm M, Motorin Y, Marchand V (2017): "Mapping and 
Quantification of tRNA 2'-O-Methylation by RiboMethSeq". Wajapeyee N., Gupta
R. (eds) Epitranscriptomics. Methods in Molecular Biology (Humana Press, 
New York, NY) 1870, P. 273-295. DOI: 
\href{https://doi.org/10.1007/978-1-4939-8808-2_21}{10.1007/978-1-4939-8808-2_21}
}
\author{
Felix G.M. Ernst [aut]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmodR.RiboMethSeq.R
\docType{data}
\name{RNAmodR.RiboMethSeq-datasets}
\alias{RNAmodR.RiboMethSeq-datasets}
\alias{msrms}
\title{Example data in the RNAmodR.RiboMethSeq package}
\format{
a \code{ModSetRiboMethSeq} instance
}
\usage{
data(msrms)
}
\description{
This contains an example ModifierSet object of type ModSetRiboMethSeq
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RNAmodR.RiboMethSeq.R
\name{RNAmodR.RiboMethSeq}
\alias{RNAmodR.RiboMethSeq}
\title{RNAmodR.RiboMethSeq}
\description{
`RNAmodR.RiboMethSeq` implements the detection of 2'-O methylations from 
RiboMethSeq data using the workflow and class the package `RNAmodR` provides.
}
\seealso{
Further details are described in the man pages of the 
\code{\link[RNAmodR:Modifier-class]{Modifier}} object and the vignettes.
}
\author{
Felix G M Ernst [aut], Denis L J Lafontaine [fnd]
}
